
#include "EBasicApp.h"
#include <uikon.hrh>
#include <reent.h>
#include <eikenv.h>

#ifndef SYMBIAN_SERIES_60
#include <quartzkeys.h>
#endif

#include <e32keys.h>
#include <eikenv.h>
#include <eikapp.h>
#include "SDL_epocvideo.h"
#include "SDL_epocevents_c.h"

#include "sdlapp.h"


CApaDocument* CSDLApp::CreateDocumentL()
{
	CEBasicDoc* doc = new (ELeave) CEBasicDoc(*this);
	return doc;
}

#ifdef UIQ
//CEBasicDoc::CEBasicDoc(CEikApplication& aApp):CQikDocument(aApp)
#else
CEBasicDoc::CEBasicDoc(CEikApplication& aApp):CEikDocument(aApp)
#endif
{
}

CEBasicDoc::~CEBasicDoc()
{
}

void CEBasicDoc::ConstructL()
{
}

CEikAppUi* CEBasicDoc::CreateAppUiL()
{
	return new (ELeave) CEBasicAppUi;
}

CEBasicAppUi::CEBasicAppUi():iSDLstart(CActive::EPriorityUserInput)
{
	iLastChar=-1;

}

CEBasicAppUi::~CEBasicAppUi()
{
	RemoveFromStack(iView);
	delete iView;
	CloseSTDLIB();
}

void CEBasicAppUi::HandleCommandL(TInt aCommand)
{
	switch(aCommand)
	{
	case EEikCmdExit:
		Exit(); //Will leave up to exit
		break;
	default:
		break;
	}

}

int EPOC_HandleWsEvent(_THIS,const TWsEvent& aWsEvent);
extern SDL_VideoDevice * _thisDevice;

void CEBasicAppUi::HandleWsEventL(const TWsEvent& aEvent, CCoeControl* aDestination)
{
	TInt type= aEvent.Type();
	if(_thisDevice!=NULL && (type == EEventPointer || type == EEventKey ||type ==EEventKeyDown || type == EEventKeyUp))
	{
		EPOC_HandleWsEvent(_thisDevice,aEvent);
		CEikAppUi::HandleWsEventL(aEvent,aDestination);
	}
	else
	{
		if(_thisDevice!=NULL && type ==EEventFocusGained)
		{
			EPOC_HandleWsEvent(_thisDevice,aEvent);
		}

		CEikAppUi::HandleWsEventL(aEvent,aDestination);
	}

}
TInt CEBasicAppUi::StaticSDLStartL(TAny* aAppUi)
{
	static_cast<CEBasicAppUi*>(aAppUi)->SDLStartL();
	return KErrNone;
}


void CEBasicAppUi::SDLStartL()
{
	main(0,NULL);
}

void CEBasicAppUi::ConstructL()
{
	CEikAppUi::ConstructL();

	iView = new (ELeave) CEBasicView;
	iView->ConstructL(ClientRect());
	iView->SetAppUi(Application()->AppDllUid());
	RegisterViewL(*iView);
	SetDefaultViewL(*iView);
	AddToStackL(*iView,iView);
	TCallBack start(StaticSDLStartL,this);
	iSDLstart.Set(start);
	iSDLstart.CallBack();
}

void CEBasicAppUi::DrawView()
{
	iView->DrawNow();
}

CEBasicView::CEBasicView()
{
	iInputState = EFalse;
	iLetterOffset=0;
}

CEBasicView::~CEBasicView()
{

}
extern bool gRightClickSet;
void CEBasicView::ConstructL(const TRect& aRect)
{
	CreateWindowL();
	SetRect(TRect(TPoint(0,0),TSize(aRect.Width(),320)));

	SetFocus(ETrue);
	EnableDragEvents();

	iDispMode = iCoeEnv->ScreenDevice()->DisplayMode();

	ActivateL();
}

void CEBasicView::Draw(const TRect& /*aRect*/) const
{
#ifndef SYMBIAN_SERIES_60
	CWindowGc& gc = SystemGc();
	//gc.SetPenColor(KRgbBlack);
	gc.SetBrushColor(KRgbBlack);
	gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
	//gc.DrawRect(aRect);
	gc.SetPenColor(KRgbWhite);
	TInt base=Size().iWidth-8;
	gc.DrawRect(TRect(TPoint(base,0),TSize(8,16))); // outerline
	gc.DrawLine(TPoint(base+2,10),TPoint(base+5,10)); 
	gc.DrawLine(TPoint(base+5,10),TPoint(base+5,4)); //enter
	gc.DrawRect(TRect(TPoint(base,16),TSize(8,16))); 
	gc.DrawRect(TRect(TPoint(base,32),TSize(8,16)));
	gc.DrawLine(TPoint(base+1,40),TPoint(base+3,34)); // arrow
	gc.DrawLine(TPoint(base+3,34),TPoint(base+6,40));

	gc.DrawRect(TRect(TPoint(base,304),TSize(8,16)));
	gc.DrawLine(TPoint(base+1,310),TPoint(base+3,317)); // arrow
	gc.DrawLine(TPoint(base+3,317),TPoint(base+6,310));

	if(gRightClickSet)
	{
	gc.SetBrushColor(KRgbBlack);
	gc.DrawRect(TRect(TPoint(base+2,26),TSize(4,4)));

	gc.SetBrushColor(KRgbWhite);
	gc.DrawRect(TRect(TPoint(base+2,18),TSize(4,4)));
	}
	else
	{
	gc.SetBrushColor(KRgbBlack);
	gc.DrawRect(TRect(TPoint(base+2,18),TSize(4,4)));
	gc.SetBrushColor(KRgbWhite);
	gc.DrawRect(TRect(TPoint(base+2,26),TSize(4,4)));

	}


	DrawCharSelector(gc);
	gc.SetPenColor(KRgbBlack);
	gc.SetBrushColor(KRgbBlack);
	gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
#endif
}

void CEBasicView::DrawCharSelector(CWindowGc& aGc) const
{
	aGc.SetPenColor(KRgbWhite);
	aGc.SetBrushColor(KRgbBlack);
	aGc.UseFont(iEikonEnv->AnnotationFont());
	TInt fntHeight = iEikonEnv->AnnotationFont()->HeightInPixels();
	TInt base=Size().iWidth-8;

	for(TInt chr=0;chr<16;chr++)
	{
		aGc.DrawRect(TRect(TPoint(base,48+chr*16),TSize(8,16)));
		if(chr+iLetterOffset<KOnScreenChars().Length())
		{
			TBuf<2>chrbuf=KOnScreenChars().Mid(chr+iLetterOffset,1);
			aGc.DrawText(chrbuf,TPoint(base+1,64+chr*16-(fntHeight/2)));
		}
	}
	aGc.DiscardFont();
}

TCoeInputCapabilities CEBasicView::InputCapabilities() const
{
	TCoeInputCapabilities caps(0);
	if(iInputState)
	{
		caps.SetCapabilities(TCoeInputCapabilities::EAllText|TCoeInputCapabilities::ENavigation);
	}
		
	return caps;
}

void CEBasicView::SetInputState(TBool aOnOff)
{
	iInputState = aOnOff;
	SetFocus(ETrue);
}

bool gViewVisible=false;

TVwsViewId CEBasicView::ViewId() const
{
	TVwsViewId view(iAppUid,TUid::Uid(0x12341234));
	return view;
}
void CEBasicView::ViewActivatedL(const TVwsViewId& /*aPrevViewId*/,TUid /*aCustomMessageId*/,const TDesC8& /*aCustomMessage*/)
{
	SetFocus(ETrue);
	MakeVisible(ETrue);
	gViewVisible=true;
}
void CEBasicView::ViewDeactivated()
{
	gViewVisible=false;
	MakeVisible(EFalse);
}

void CEBasicView::UpdateCharSelector(TInt aLetterOffset)
{
	iLetterOffset=aLetterOffset;
	ActivateGc();
	CWindowGc& gc = SystemGc();
	gc.SetPenColor(KRgbWhite);
	gc.SetBrushColor(KRgbBlack);
	gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
	DrawCharSelector(gc);
	DeactivateGc();
}
