#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikmenub.h>
#include <eiklbx.h>
#include <qikon.hrh>
#include <qikcategorymodel.h>

#include "QSDLListView.h"
#include "q_sdl_external_interface.h"
#include "QSDLModel.h"
#include <oIM.rsg>
#include "oIM.hrh"
#include "QSDLUi.h"


// Get the intial list of shapes in the view
CQSDLListView::CQSDLListView()
	{
	SetListObjects(EAll);
	}

// Store a pointer the view's list box
void CQSDLListView::SetListBox(CEikListBox& aListBox)
	{
	iListBox = &aListBox;
	}

CQSDLListView::~CQSDLListView()
	{
	iObjectsInView.Close();
	}

// On view activation, change the menu and toolbar
void CQSDLListView::ViewActivatedL(const TVwsViewId& /*aPrevViewId*/, 
	TUid /*aCustomMessageId*/,const TDesC8& /*aCustomMessage*/)
	{
	// Change menu
	MEikAppUiFactory* factory = iEikonEnv->AppUiFactory();	
	factory->MenuBar()->ChangeMenuBarL(0, R_OIM_LIST_MENUBAR, ETrue);

	// Change toolbar
	iAppUi->SetToolbarL(R_OIM_LIST_TOOLBAR);

	// Set listbox back to default
	RefreshListBoxL();
	iListBox->SetCurrentItemIndex(0);
	}

// On view activation, hide the view
void CQSDLListView::ViewDeactivated()
	{
	MakeVisible(EFalse);
	}

// Responds to the user changing the category.
void CQSDLListView::HandleCategoryChangeL(TInt aHandle)
	{
	// Reset the list of objects in the view
	SetListObjects(aHandle);
	// Prompt the list box to refresh its model and redraw
	RefreshListBoxL();
	iListBox->DrawNow();
	}

// Filters the list view's array of colored shapes, so that only 
// the shapes in the selected category are included
void CQSDLListView::SetListObjects(TInt aHandle)
	{
	/*
	iObjectsInView.Reset();
	const TQSDLModel::TColoredShapeArray& shapes = iModel->ColoredShapeArray();
	for (TInt i=0; i<shapes.Count(); i++)
		{
		if (  (aHandle == EAll) 
			||((aHandle == ESquare) && (shapes[i].iShapeType == TQSDLModel::ESquare))
			||((aHandle == ECircle) && (shapes[i].iShapeType == TQSDLModel::ECircle)))
			iObjectsInView.Append(&shapes[i]);
		}
	*/
	}

// Respond to user clicking on a shape in the list box by switching to the
// detailed view for that shape
void CQSDLListView::HandleListBoxEventL(CEikListBox* aListBox, TListBoxEvent aEventType)
	{
/*	if((aListBox == iListBox) && (aEventType == EEventItemClicked))
		{
		// Switch to detailed view by DNL, with shape ID as argument
		TVwsViewId id(KUidQSDL, KUidQSDLDetailView);
		TQSDLDNLDetailed dnl;
		CQSDLModel::TColoredShape* shape = iObjectsInView[iListBox->CurrentItemIndex()];
		dnl.iID = shape->iID;
		TQSDLDNLDetailedBuf dnlBuf(dnl);
		iAppUi->ActivateViewL(id, KUidQSDLDetailedDNL, dnlBuf);
		}
*/
	}

// Get array of shapes in view
const CQSDLListView::TCSPtrArray& CQSDLListView::ObjectsInView() const
	{
	return iObjectsInView;
	}
