/****************
 * CQSDLUi
 * Copyrigth (c) 2002 Andreas Karlsson
 */

#ifndef __OIM_QIK_QOIMUI_H__
#define __OIM_QIK_QOIMUI_H__

#include <qikappui.h>

class CQSDLUserListView;
class CQSDLViewBase;
//class CQBasicAppGraphicsListView;

// Application's UI. It constructs and registers the views, and handles commands
class CQSDLUi : public CQikAppUi
	{
public:
	// Construction and destruction
	CQSDLUi();
	void ConstructL();
	~CQSDLUi();

	// Returns currently selected category
	TInt CurrentCategory();

private:
	// Implements CEikAppUi
	void HandleCommandL(TInt aCommand);
	
	// Implements CQikAppUi
	void HandleCategoryChangeL(TInt aHandle);

	// Implements MEikMenuObserver
	void DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane);
	void DynInitMenuBarL(TInt aResourceId, CEikMenuBar* aMenuBar);

	// Gets a pointer to the currently active view
	CQSDLViewBase* CurrentView();

	// Handles a switch to a target view
	void SwitchViewL(const TUid& aTargetViewId, CQSDLViewBase& aTargetView);

private:
	// The graphics view
//	CQBasicAppGraphicsListView* iGraphicsListView;
	// The text view
	CQSDLUserListView* iUserListView;
	// Currently selected category
	TInt iCurrentCategory;
	};

#endif //__OIM_QIK_QOIMUI_H__

