#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikmenub.h>
#include <eiktxlbx.h>
#include <eiktxlbm.h>
#include <eiklbx.h>
#include <eiklbi.h>
#include <qikon.hrh>


#include "q_sdl_external_interface.h"
#include "QSDLUserListView.h"
#include "QSDLUi.h"

CQSDLUserListView::CQSDLUserListView()
	{
	}

CQSDLUserListView::~CQSDLUserListView()
	{
	delete iUserListBox;
	}

CQSDLUserListView* CQSDLUserListView::NewL()
	{
	CQSDLUserListView* self = new(ELeave) CQSDLUserListView();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
	}

void CQSDLUserListView::ConstructL()
	{
	// Set up the view's window
	CreateWindowL();
	TRect rect = iAppUi->ClientRect();
	SetRect(rect);

	// Create a string array in which to hold the descriptions 
	// of the colored shapes
	iStringArray = new (ELeave) CDesC16ArrayFlat(10);

	// Set up a text list box in which to display the colored shape list
	iUserListBox = new (ELeave) CEikTextListBox;
	iUserListBox -> ConstructL(this,CEikListBox::ENoExtendedSelection|CEikListBox::ENoFirstLetterMatching);
	iUserListBox -> SetPosition(TPoint(0,0));
	iUserListBox -> SetSize(rect.Size());
	iUserListBox -> SetListBoxObserver(this);
	iUserListBox -> Model() -> SetItemTextArray(iStringArray);
	iUserListBox -> View() -> ItemDrawer() -> SetDrawMark(EFalse);
	SetListBox(*iUserListBox);

	

	// Make view and components invisible until ViewActivated has been called
	MakeVisible(EFalse);
	SetComponentsToInheritVisibility();
	ActivateL();
	}

// View activation-the base class handles everything but actually
// makng the view visible
void CQSDLUserListView::ViewActivatedL(const TVwsViewId& aPrevViewId, 
	TUid aCustomMessageId,const TDesC8& aCustomMessage)
	{
	CQSDLListView::ViewActivatedL(aPrevViewId, aCustomMessageId, aCustomMessage);
	MakeVisible(ETrue);
	}

// Fill the list box's model with descriptions of the shapes in the view
void CQSDLUserListView::RefreshListBoxL()
	{
/*
	iStringArray->Reset();
	TInt numObjects = iObjectsInView.Count();
	const TQSDLModel::TColoredShape* shape;
	_LIT(KGreen,"Green");
	_LIT(KRed,"Red");
	_LIT(KBlue,"Blue");
	_LIT(KSquare," square");
	_LIT(KCircle," circle");

	TBuf<20> description;

	// Loop through shapes, generating descriptions
	for (TInt i=0; i<numObjects; i++)
		{
		description.Zero();
		shape = iObjectsInView[i];
		if (shape->iColor == KRgbDarkGreen)
			description.Append(KGreen);
		else if (shape->iColor == KRgbRed)
			description.Append(KRed);
			else
				description.Append(KBlue);
		if (shape->iShapeType == QSDLModel::ECircle)
			description.Append(KCircle);
		else
			description.Append(KSquare);
		iStringArray->AppendL(description);
		}

	// Set the list box to use the new array
	iUserListBox->View()->CalcBottomItemIndex();
*/
	}


TUid CQSDLUserListView::ViewUid() const
	{
	return KUidQSDLUserListView;
	}

// Standard functions for making compound controls
CCoeControl* CQSDLUserListView::ComponentControl(TInt aIndex) const
	{
	if(aIndex == 0)
		{
		return iUserListBox;
		}
	return NULL;
	}

TInt CQSDLUserListView::CountComponentControls() const
	{
	return 1;
	}
