#ifndef __OIM_QIK_QOIMVIEWBASE_H__
#define __OIM_QIK_QOIMVIEWBASE_H__

#include <coecntrl.h>
#include <coeview.h>

class CQSDLUi;
class CQikCategoryModel;

class CQSDLModel;


// Base class for all views in this application.
// It provides support for handling category changes and view UIDs.
// It could be extended to handle e.g. persisting view settings, and 
// zooming
class CQSDLViewBase : public CCoeControl, public MCoeView
	{
public:
	// Require subclasses to handle category changes
	virtual void HandleCategoryChangeL(TInt aHandle)=0;

	// Implements MCoeView
	TVwsViewId ViewId() const;

protected:
	CQSDLViewBase();

	// Require subclasses to return the view UID
	virtual TUid ViewUid() const = 0;

protected:
	// Provide useful data to subclasses

	// The model
	CQSDLModel* iModel;
	// Category information
	CQikCategoryModel* iCategoryModel;
	// App UI
	CQSDLUi* iAppUi;
	};

#endif // __OIM_QIK_QOIMVIEWBASE_H__

