/***********************
 * QSDLDirectDisplay.h
 * 
 * Copyright 2002 Andreas Karlsson
 * All rights reserved.
 */

#ifndef __SDL_VIDEO_EPOC_QSDLDIRECTDISPLAY_H__
#define __SDL_VIDEO_EPOC_QSDLDIRECTDISPLAY_H__

#include <e32base.h>
#include <w32std.h>

#include <bitstd.h>

class CQSDLDirectDisplay : public CBase, public MDirectScreenAccess
{
public:
	static CQSDLDirectDisplay *NewL(RWsSession& aClient, RWindow& aWindow, CWsScreenDevice &aDevice );
	static CQSDLDirectDisplay *NewLC(RWsSession& aClient, RWindow& aWindow, CWsScreenDevice &aDevice );

	~CQSDLDirectDisplay();

	void StartL();
	void Cancel();

	//Implements MDirectScreenAccess
	void Restart(RDirectScreenAccess::TTerminationReasons aReason);
	void AbortNow(RDirectScreenAccess::TTerminationReasons aReason);

	CFbsBitGc	&Gc();

	/** 
	 * Check if both is needed or if you can do update and flush in the same method
	 *
	 * for emulator
	 */
	void		Update();
	void		Flush();
private:
	CQSDLDirectDisplay( RWsSession& aClient, RWindow& aWindow );
	void ConstructL( CWsScreenDevice &aDevice );

	RWsSession			&iClient;
	RWindow				&iWindow;

	CDirectScreenAccess	*iDirectScreenAccess;
	CFbsBitGc			*iGc;
	RRegion				*iRegion;
};

/**
 * Used for Offscreen double buffering
 */
class CDirectFbsBitmap : public CFbsBitmap
{
public:
		void LockHeap()
		{
			CFbsBitmap::LockHeap();
		}

		CBitwiseBitmap	*BitwiseBitmap()
		{
			return iAddressPointer;
		}
};

#endif //__SDL_VIDEO_EPOC_QSDLDIRECTDISPLAY_H__
